//
//  ConfirmBuyView.m
//  BeautifulWardrobe
//
//  Created by mac on 16-4-3.
//  Copyright (c) 2016年 zhiyou. All rights reserved.
//

#import "ConfirmBuyView.h"
#import "AutoLayoutView.h"
@implementation ConfirmBuyView


- (id)initWithFrame:(CGRect)frame {
    
    self = [super initWithFrame:frame];
    if (self) {
        
        self.backgroundColor = [UIColor colorWithRed:135/255.0 green:135/255.0 blue:135/255.0 alpha:0.2];
        //control 点击屏幕上方 View消失
        self.control = [[UIControl alloc]initWithFrame:CGRectMake(0, 0, self.bounds.size.width, self.bounds.size.height-280)];
        [self.control addTarget:self action:@selector(controlClick) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:self.control];
        
        self.selectProductInfoView = [[UIView alloc]initWithFrame:CGRectMake(0, self.bounds.size.height,self.bounds.size.width , 280)];
        self.selectProductInfoView.backgroundColor = [UIColor whiteColor];
        self.selectProductInfoView.tag = 1000;
        [self addSubview:self.selectProductInfoView];
        //退出按钮
        UIButton *exitButton = [UIButton buttonWithType:UIButtonTypeCustom];
        exitButton.frame = CGRectMake(self.bounds.size.width-40, 10, 30, 30);
        [exitButton setBackgroundImage:[UIImage imageNamed:@"button_close_BuyProduct"] forState:UIControlStateNormal];
        [exitButton addTarget:self action:@selector(exitButtonClick) forControlEvents:UIControlEventTouchUpInside];
        [self.selectProductInfoView addSubview:exitButton];
        
        //图片
        self.productImage = [[UIImageView alloc]initWithFrame:CGRectMake(5,5 , 70, 70)];
        self.productImage.image = [UIImage imageNamed:@"taobao_head_29.jpeg"];
        [self.selectProductInfoView addSubview:self.productImage];
        //标题
        UILabel *titleLabel = [[UILabel alloc]initWithFrame:CGRectMake(90, 10, self.bounds.size.width-135, 20)];
        titleLabel.text = @"~~~~~~";
        titleLabel.font = [UIFont systemFontOfSize:15];
        [self.selectProductInfoView addSubview:titleLabel];
        //增加按钮
        _addButton = [CustomButton buttonWithType:UIButtonTypeCustom];
        _addButton.frame = CGRectMake(self.bounds.size.width/2+120, 45, 25, 25);
        [_addButton setBackgroundImage:[UIImage imageNamed:@"button_product_numberadd"] forState:UIControlStateNormal];
        [_addButton addTarget:self action:@selector(addButtonClick:) forControlEvents:UIControlEventTouchUpInside];
        [self.selectProductInfoView addSubview:_addButton];
        //减少
        _reduceButotn = [CustomButton buttonWithType:UIButtonTypeCustom];
        _reduceButotn.frame = CGRectMake(self.bounds.size.width/2+35, 45, 25, 25);
        [_reduceButotn setBackgroundImage:[UIImage imageNamed:@"button_product_numbersub_enable"] forState:UIControlStateNormal];
        [_reduceButotn addTarget:self action:@selector(reduceButotnClick) forControlEvents:UIControlEventTouchUpInside];
        [self.selectProductInfoView addSubview:_reduceButotn];
        
        //提示
        self.tipLabel = [[UILabel alloc]initWithFrame:CGRectMake(90, 60,100 , 20)];
        self.tipLabel.text = @"请选择";
        self.tipLabel.font = [UIFont systemFontOfSize:15];
        self.tipLabel.textColor = [UIColor grayColor];
        [self.selectProductInfoView addSubview:self.tipLabel];

        //数量
        _numLabel = [[UILabel alloc]initWithFrame:CGRectMake(self.bounds.size.width/2+65, 45, 50, 25)];
        _numLabel.text = @"1";
        _numLabel.layer.borderColor = [UIColor grayColor].CGColor;
        _numLabel.layer.borderWidth = 0.3;
        _numLabel.textAlignment = NSTextAlignmentCenter;
        _numLabel.adjustsFontSizeToFitWidth = YES;
        
        [self.selectProductInfoView addSubview:_numLabel];
        self.myScrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, 85, self.bounds.size.width, self.selectProductInfoView.bounds.size.height-85-44)];
        self.myScrollView.contentSize = CGSizeMake(self.bounds.size.width, self.myScrollView.bounds.size.height+50);
        [self.selectProductInfoView addSubview:self.myScrollView];
        
        UILabel *color = [[UILabel alloc]initWithFrame:CGRectMake(5, 5, 40, 30)];
        color.text = @"颜色";
        color.textColor = [UIColor grayColor];
        color.textAlignment = NSTextAlignmentCenter;
        color.font = [UIFont systemFontOfSize:15];
        [self.myScrollView addSubview:color];
        
        UILabel *sizeLabel = [[UILabel alloc]initWithFrame:CGRectMake(5, 80, 40, 30)];
        sizeLabel.text = @"尺码";
        sizeLabel.textColor = [UIColor grayColor];
        sizeLabel.textAlignment = NSTextAlignmentCenter;
        sizeLabel.font = [UIFont systemFontOfSize:15];
        [self.myScrollView addSubview:sizeLabel];

        //初始数量为1
        count = 1;
    }
    return self;
}
- (void)exitButtonClick {

     UIView *view = [self viewWithTag:1000];
    __weak ConfirmBuyView *weakSelf = self;
    [UIView animateWithDuration:0.5 animations:^{
        
        view.frame = CGRectMake(0, self.bounds.size.height,self.bounds.size.width, 280);

    } completion:^(BOOL finished) {
        
        [weakSelf removeFromSuperview];
    }];
  
}
- (void)controlClick {
    
    __weak ConfirmBuyView *weakSelf = self;
    [UIView animateWithDuration:1 animations:^{
        self.selectProductInfoView.frame = CGRectMake(0, self.bounds.size.height+280, self.bounds.size.width, 280);
    } completion:^(BOOL finished) {
        
        [weakSelf removeFromSuperview];
    }];
}
- (void)colorButtonClick:(CustomButton *)sender {
    
    //两次点击的是同一个按钮不再执行此方法
    if (_recordButton == sender) {
        
        return;
    }
    //按钮如果是灰色的不执行 (此商品没有库存了)
    if (sender.isGray == YES) {
        return;
    }
    
    self.color = sender.titleLabel.text;
    //遍历整个数组
    for (DataModel *model in self.infoArray) {
        //按照所选的颜色 找到所对应的尺码
        if ([model.color isEqualToString:sender.titleLabel.text]) {
            
            NSInteger index = [self.sizeArray indexOfObject:model.size];
            //通过index找到view上相对应的按钮
            CustomButton *button = (CustomButton *)[self.sizesView viewWithTag:index+2000];
            if ([model.quantity intValue]>0) {
                //有库存,改变成黑色,前提是这个按钮不是红色(没有点击过)
                button.isGray = NO;
                if ( button.isRed == NO) {
                    
                    button.layer.borderColor = [UIColor blackColor].CGColor;
                    [button setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
                }
               
            }else {
                 //没有库存,灰色 不可以点击状态
                button.layer.borderColor = [UIColor grayColor].CGColor;
                [button setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
                button.isGray = YES;
                    
                }
            }
        }
    //提示用户选择尺码
    if (self.size == nil) {
        
        self.tipLabel.text = @"请选择尺码";
    }else {
        
        [self quantity];
    }
    
    if (_recordButton) {
        
        _recordButton.layer.borderColor = [UIColor blackColor].CGColor;
        [_recordButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
        _recordButton.isRed = NO;
    }
    
    sender.layer.borderColor = [UIColor redColor].CGColor;
    [sender setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
    sender.isRed = YES;
    _recordButton = sender;
   
}
- (void)sizeButtonClick:(CustomButton *)sender {
    
    if (_recordSizeButton == sender) {
        
        return;
    }
    if (sender.isGray == YES) {
        return;
    }
    self.size = sender.titleLabel.text;
    for (DataModel *model in self.infoArray) {
        
        if ([model.size isEqualToString:sender.titleLabel.text]) {
            
            NSInteger index = [self.styleArray indexOfObject:model.color];
            CustomButton *button = (CustomButton *)[self.stylesView viewWithTag:index+100];
            if ([model.quantity intValue]>0) {
                
                 button.isGray = NO;
                if (button.isRed == NO) {
                    button.layer.borderColor = [UIColor blackColor].CGColor;
                    [button setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
                }
               
            }else {
                
                button.layer.borderColor = [UIColor grayColor].CGColor;
                [button setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
                button.isGray = YES;
                
            }
        }
    }
    //提示用户选择颜色
    if (self.color == nil) {
        
        self.tipLabel.text = @"请选择颜色";
    }else {
        [self quantity];
    }
    if (_recordSizeButton) {
        
        _recordSizeButton.layer.borderColor = [UIColor blackColor].CGColor;
        [_recordSizeButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
        _recordSizeButton.isRed = NO;
    }
    
    sender.layer.borderColor = [UIColor redColor].CGColor;
    [sender setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
    
    sender.isRed = YES;
    _recordSizeButton = sender;
    
}

- (void)addButtonClick:(CustomButton *)sender {

        count+=1;
        _numLabel.text = [NSString stringWithFormat:@"%@",@(count)];
    if (_reduceButotn.isRed == NO) {
        
        [_reduceButotn setBackgroundImage:[UIImage imageNamed:@"button_product_numbersub"] forState:UIControlStateNormal];
        _reduceButotn.isRed = YES;

    }
}

- (void)reduceButotnClick {
    
    count-=1;
    if (count <=1) {
        [_reduceButotn setBackgroundImage:[UIImage imageNamed:@"button_product_numbersub_enable"] forState:UIControlStateNormal];
        count = 1;
        _numLabel.text = [NSString stringWithFormat:@"%@",@(count)];
        _recordButton.isRed = NO;
        return;
    }
    _numLabel.text = [NSString stringWithFormat:@"%@",@(count)];
    
}


- (void)quantity {
    
    for (DataModel *model in self.infoArray) {
        
        if ([model.color isEqualToString:self.color]&&[model.size isEqualToString:self.size]) {
            
            self.tipLabel.text = [NSString stringWithFormat:@"库存:(%@)",model.quantity];
        }
    }
    
}
- (void)setStyleArray:(NSMutableArray *)styleArray {
    
    _styleArray = styleArray;
    
    self.stylesView = [[AutoLayoutView alloc]initWithArray:styleArray];
    self.stylesView.frame = CGRectMake(0, 10, self.bounds.size.width, self.stylesView.maxY);
    [self.myScrollView addSubview:self.stylesView];
    
    for (int i = 0; i <self.stylesView.subviews.count; i++) {
        
        CustomButton *button = (CustomButton *)self.stylesView.subviews[i];
        button.tag = i + 100;
        [button addTarget:self action:@selector(colorButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    }

}

- (void)setSizeArray:(NSMutableArray *)sizeArray {
    
    _sizeArray = sizeArray;
    
    self.sizesView = [[AutoLayoutView alloc]initWithArray:self.sizeArray];
    self.sizesView.frame = CGRectMake(0, 45+self.stylesView.maxY, self.bounds.size.width, self.sizesView.maxY);
    
    if (self.sizeArray.count <= 1) {
        
        CustomButton *button = self.sizesView.subviews[0];
        self.size = button.titleLabel.text;
        
    }else {
        
        for (int i = 0; i <self.sizesView.subviews.count; i++) {
            
            CustomButton *button = (CustomButton *)self.sizesView.subviews[i];
            button.tag = 2000+i;
            
            [button addTarget:self action:@selector(sizeButtonClick:) forControlEvents:UIControlEventTouchUpInside];
        }
        
    }
    [self.myScrollView addSubview:self.sizesView];
    
 
}

@end
